#!/usr/bin/env bash

# Load the required environment
# Load the requested R module (required)
module load <%= context.mod_r_modules %>

<%- unless context.mod_extra.blank? -%>
# Load additional modules (optional)
module load <%= context.mod_extra %>
<%- end -%>

#
# Start RStudio Server
#

# PAM auth helper used by RStudio
export RSTUDIO_AUTH="${PWD}/bin/auth"

# Generate an `rsession` wrapper script
export RSESSION_WRAPPER_FILE="${PWD}/rsession.sh"
(
umask 077
sed 's/^ \{2\}//' > "${RSESSION_WRAPPER_FILE}" << EOL
  #!/usr/bin/env bash

  # Log all output from this script
  export RSESSION_LOG_FILE="${PWD}/rsession.log"

  exec &>>"\${RSESSION_LOG_FILE}"

  # Launch the original command
  echo "Launching rsession..."
  set -x
  exec rsession --r-libs-user "${R_LIBS_USER}" "\${@}"
EOL
)
chmod 700 "${RSESSION_WRAPPER_FILE}"

# Set working directory to home directory
cd "${HOME}"

# Prepare temporary dir
export TMPDIR="$(mktemp -d)"

mkdir -p $TMPDIR/rstudio-server
SECURE_COOKIE_KEY="${TMPDIR}/rstudio-server/secure-cookie-key"
python -c 'from uuid import uuid4; print(uuid4())' > ${SECURE_COOKIE_KEY}
chmod 0600 ${SECURE_COOKIE_KEY}

echo "directory=${TMPDIR}/" > ${TMPDIR}/rstudio-server/database.conf

set -x
# Launch the RStudio Server
echo "Starting up rserver..."

rserver --www-port "${port}" \
  --auth-none 0 \
  --auth-pam-helper-path "${RSTUDIO_AUTH}" \
  --auth-encrypt-password 0 \
  --server-data-dir "${TMPDIR}/" \
  --secure-cookie-key-file ${SECURE_COOKIE_KEY} \
  --database-config-file "${TMPDIR}/rstudio-server/database.conf" \
  --rsession-path "${RSESSION_WRAPPER_FILE}" \
  --server-user $USER

echo 'Rserver has exited...'
